summaryrefslogtreecommitdiffstats
path: root/usr.sbin/pc-sysinstall/backend-partmanager
diff options
context:
space:
mode:
authorimp <imp@FreeBSD.org>2010-06-24 22:21:47 +0000
committerimp <imp@FreeBSD.org>2010-06-24 22:21:47 +0000
commit25b9228f868d08663a89872cbdb8785c8c4a0283 (patch)
treec3089cf79d584cec44ba428bf01ed64dab215317 /usr.sbin/pc-sysinstall/backend-partmanager
parent866d360f3fad296b08b7b176b2a5e1fa2c0e16e2 (diff)
downloadFreeBSD-src-25b9228f868d08663a89872cbdb8785c8c4a0283.zip
FreeBSD-src-25b9228f868d08663a89872cbdb8785c8c4a0283.tar.gz
Bring in Kris Moore's pc-sysinstall shell script from PC-BSD. This
shell script is the back end logic necessary for an installer. It contains both query routines to allow a front-end installer to present reasonable choices to the user and also action routines which allow the front end installer to put a FreeBSD distribution onto a disk. It supports installing onto the usual suspects, as well as advanced features like Mirroring, ZFS, Encryprion and GPT labels. While this is only the back-end of the installer, it can do unattended scripted installations. In PC-BSD's world view, all installations are scripted and all the front-end does is write the script. As such, it is useful in its own right. This has been extensively tested over the past several releases of PC-BSD. However, differences between that environment and FreeBSD suggest there will be a period of shake-out while those differences are discovered and corrected. A text-based front-end is in the works. For the GUI-based front-end, you can use the PC-BSD distribution. Kris' BSDcan paper on pc-sysinstall is linked off his talk on the BSDcan site: http://www.bsdcan.org/2010/schedule/events/173.en.html The man page is written by Josh Paetzel, and I wrote the Makefiles for the FreeBSD integration. Kris wrote the rest. This represents version r7010 in the PC-BSD repo. http://svn.pcbsd.org/pcbsd/current/pc-sysinstall Submitted by: kris@ Sponsored by: iX Systems
Diffstat (limited to 'usr.sbin/pc-sysinstall/backend-partmanager')
-rw-r--r--usr.sbin/pc-sysinstall/backend-partmanager/Makefile8
-rwxr-xr-xusr.sbin/pc-sysinstall/backend-partmanager/create-part.sh92
-rwxr-xr-xusr.sbin/pc-sysinstall/backend-partmanager/delete-part.sh89
3 files changed, 189 insertions, 0 deletions
diff --git a/usr.sbin/pc-sysinstall/backend-partmanager/Makefile b/usr.sbin/pc-sysinstall/backend-partmanager/Makefile
new file mode 100644
index 0000000..61c407a
--- /dev/null
+++ b/usr.sbin/pc-sysinstall/backend-partmanager/Makefile
@@ -0,0 +1,8 @@
+# $FreeBSD$
+
+FILES= create-part.sh delete-part.sh
+
+FILESDIR=${SHAREDIR}/pc-sysinstall/backend-partmanager
+NO_OBJ=
+
+.include <bsd.prog.mk>
diff --git a/usr.sbin/pc-sysinstall/backend-partmanager/create-part.sh b/usr.sbin/pc-sysinstall/backend-partmanager/create-part.sh
new file mode 100755
index 0000000..8cb3761
--- /dev/null
+++ b/usr.sbin/pc-sysinstall/backend-partmanager/create-part.sh
@@ -0,0 +1,92 @@
+#!/bin/sh
+#-
+# Copyright (c) 2010 iX Systems, Inc. All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+
+# Query a disk for partitions and display them
+#############################
+
+. ${PROGDIR}/backend/functions.sh
+
+if [ -z "${1}" ] ; then
+ echo "Error: No disk specified!"
+ exit 1
+fi
+
+if [ -z "${2}" ] ; then
+ echo "Error: No size specified!"
+ exit 1
+fi
+
+if [ ! -e "/dev/${1}" ] ; then
+ echo "Error: Disk /dev/${1} does not exist!"
+ exit 1
+fi
+
+DISK="${1}"
+MB="${2}"
+
+TOTALBLOCKS="`expr $MB \* 2048`"
+
+
+# Lets figure out what number this slice will be
+LASTSLICE="`fdisk -s /dev/${DISK} 2>/dev/null | grep -v ${DISK} | grep ':' | tail -n 1 | cut -d ':' -f 1 | tr -s '\t' ' ' | tr -d ' '`"
+if [ -z "${LASTSLICE}" ] ; then
+ LASTSLICE="1"
+else
+ LASTSLICE="`expr $LASTSLICE + 1`"
+fi
+
+if [ ${LASTSLICE} -gt "4" ] ; then
+ echo "Error: FreeBSD MBR setups can only have a max of 4 slices"
+ exit 1
+fi
+
+
+SLICENUM="${LASTSLICE}"
+
+# Lets get the starting block
+if [ "${SLICENUM}" = "1" ] ; then
+ STARTBLOCK="63"
+else
+ # Lets figure out where the prior slice ends
+ checkslice="`expr ${SLICENUM} - 1`"
+
+ # Get starting block of this slice
+ fdisk -s /dev/${DISK} | grep -v "${DISK}:" | grep "${checkslice}:" | tr -s " " >${TMPDIR}/pfdisk
+ pstartblock="`cat ${TMPDIR}/pfdisk | cut -d ' ' -f 3`"
+ psize="`cat ${TMPDIR}/pfdisk | cut -d ' ' -f 4`"
+ STARTBLOCK="`expr ${pstartblock} + ${psize}`"
+fi
+
+
+# If this is an empty disk, see if we need to create a new MBR scheme for it
+gpart show ${DISK} >/dev/null 2>/dev/null
+if [ "$?" != "0" -a "${SLICENUM}" = "1" ] ; then
+ gpart create -s mbr ${DISK}
+fi
+
+gpart add -b ${STARTBLOCK} -s ${TOTALBLOCKS} -t freebsd -i ${SLICENUM} ${DISK}
+exit "$?"
diff --git a/usr.sbin/pc-sysinstall/backend-partmanager/delete-part.sh b/usr.sbin/pc-sysinstall/backend-partmanager/delete-part.sh
new file mode 100755
index 0000000..f524a83
--- /dev/null
+++ b/usr.sbin/pc-sysinstall/backend-partmanager/delete-part.sh
@@ -0,0 +1,89 @@
+#!/bin/sh
+#-
+# Copyright (c) 2010 iX Systems, Inc. All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+
+# Delete a specified partition, takes effect immediately
+########################################################
+
+. ${PROGDIR}/backend/functions.sh
+. ${PROGDIR}/backend/functions-disk.sh
+
+if [ -z "${1}" ]
+then
+ echo "Error: No partition specified!"
+ exit 1
+fi
+
+if [ ! -e "/dev/${1}" ]
+then
+ echo "Error: Partition /dev/${1} does not exist!"
+ exit 1
+fi
+
+PARTITION="${1}"
+
+# First lets figure out the partition number for the given device
+##################################################################
+
+# Get the number of characters in this dev
+CHARS="`echo $PARTITION | wc -c`"
+
+PARTINDEX=""
+
+# Lets read through backwards until we get the part number
+while
+z=1
+do
+ CHARS=`expr $CHARS - 1`
+ LAST_CHAR=`echo "${PARTITION}" | cut -c $CHARS`
+ echo "${LAST_CHAR}" | grep "^[0-9]$" >/dev/null 2>/dev/null
+ if [ "$?" = "0" ] ; then
+ PARTINDEX="${LAST_CHAR}${PARTINDEX}"
+ else
+ break
+ fi
+done
+
+# Now get current disk we are working on
+CHARS=`expr $CHARS - 1`
+DISK="`echo $PARTITION | cut -c 1-${CHARS}`"
+
+# Make sure we have a valid disk name still
+if [ ! -e "/dev/${DISK}" ] ; then
+ echo "Error: Disk: ${DISK} doesnt exist!"
+ exit 1
+fi
+
+echo "Running: gpart delete -i ${PARTINDEX} ${DISK}"
+gpart delete -i ${PARTINDEX} ${DISK} >/dev/null 2>/dev/null
+
+# Check if this was the last partition and destroy the disk geom if so
+get_disk_partitions "${DISK}"
+if [ -z "${VAL}" ] ; then
+ gpart destroy ${DISK}
+fi
+
+exit "$?"
OpenPOWER on IntegriCloud